import { Component, Input, ElementRef, Renderer } from "@angular/core";

@Component({
    selector: "oloader",
    templateUrl: "oloader.html"
})
export class OLoader {

    private static readonly BUBBLES = "bubbles";
    private static readonly CRESCENT = "crescent";
    private static readonly CIRCLES = "circles";
    private static readonly DOTS = "dots";

    @Input()
    type: string;

    @Input()
    text: string;

    constructor(
        public el: ElementRef,
        public renderer: Renderer
    ) {
        this.type = OLoader.BUBBLES;
        this.text = "Cargando, espere...";
    }

    /**
     *
     */
    show(): void {
        this.renderer.setElementClass(this.el.nativeElement, "oloader-show", true);
    }

    /**
     *
     */
    hide(): void {
        this.renderer.setElementClass(this.el.nativeElement, "oloader-show", false);
    }
}