import * as Moment from "moment";

export class BaseModel {

    private static readonly DEFAULT_DATE_FORMAT = "DD/MM/YYYY d:mm:ss"

    public id: string;
    public remote_id: number;
    public doc_state: string;
    public create_date: string;
    public write_date: string;

    constructor() {
        this.id = null;
        this.remote_id = 0;
        this.doc_state = "created";
        this.create_date = !this.create_date ? Moment.utc().format(BaseModel.DEFAULT_DATE_FORMAT) : this.create_date;
        this.write_date = Moment.utc().format(BaseModel.DEFAULT_DATE_FORMAT);
    }
}