import { BaseModel } from "./base.model";
 
export class Product extends BaseModel {

    public default_code: string;
    public description: string;
    public ean13: string;
    public image_medium: string;
    public image_small: string;
    public name: string;
    public list_price: number;
    public purchase_ok: boolean;
    public qty_available: number;
    public rental: boolean;
    public sale_ok: boolean;
    public standard_price: number;
    public type: string;
    public website_published: false;
    public company_id: number;
    public attribute_line_ids: Array<any>;

    constructor() {
        super();

        this.default_code = null;
        this.description = null;
        this.ean13 = null;
        this.image_medium = null;
        this.image_small = null;
        this.name = null;
        this.list_price = 1;
        this.purchase_ok = false;
        this.qty_available = 0;
        this.rental = false;
        this.standard_price = 1;
        this.type = "product";
        this.website_published = false;
        this.company_id = 0;
        this.attribute_line_ids = [];
    }
}
